<link rel="import" href="../polymer/polymer-element.html">
<script>
  class HookYouTubeCallbackMediatorImpl {
    constructor() {
      this.ready = false;
      this.loaded = false;
      this.originalYouTubeIframeReadyHandler = window.onYouTubeIframeAPIReady;
      this.callbacks = [];
      Object.defineProperty(window, 'onYouTubeIframeAPIReady', { 
        set: (val) => {
          this.ready = true;
          this.pushCallback(val);
        }, 
        get: () => {
          return () => {
            this.executeCallbacks();
            this.loaded = true;
          }
        }
      });
      this.createYouTubeScript();
    }
    createYouTubeScript() {
      var script = document.createElement('script');
      script.src = 'https://www.youtube.com/iframe_api';
      document.body.appendChild(script);
    }
    disable() {
      delete window.onYouTubeIframeAPIReady;
      window.onYouTubeIframeAPIReady = this.originalYouTubeIframeReadyHandler;
    }
    pushCallback(fnct) {
      if(this.loaded) {
        fnct();
        return;
      }
      if(fnct) {
        this.callbacks.push(fnct);
      }
    }
    executeCallbacks() {
      for(let i = 0; i < this.callbacks.length; i++) {
        let callback = this.callbacks[i];
        callback();
      }
      this.callbacks = null;
    }
  }
  window.ytApiMediator = new HookYouTubeCallbackMediatorImpl();
</script>


<dom-module id="hook-youtube-api">
  <template>
  </template>
  <script>
    /**
     * `hook-youtube-api`
     * Polymer 2 element for loading up the YouTube iFrame API and binding it to a `ready` property.
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
     class HookYouTubeApi extends Polymer.Element {
      static get is() { return 'hook-youtube-api'; }
      static get properties() {
        return {
          loaded: {
            type: Boolean,
            notify: true,
            reflectToAttribute: true,
            value: false
          }
        };
      }
      connectedCallback() {
        super.connectedCallback();
        if(window.ytApiMediator.ready) {
          this.loaded = true;
        }
        else {
          window.ytApiMediator.pushCallback(() => {
            this.loaded = true;
          });
        }
      }
    }

    window.customElements.define(HookYouTubeApi.is, HookYouTubeApi);
  </script>
</dom-module>
